#ifndef _ADAPTER_API_H_
#define _ADAPTER_API_H_

#if defined(__cplusplus)
    extern "C" {
#endif

#include "adapter.h"

unsigned long BusClose(s_Adapter *p_HW);
unsigned long BusOpen(s_Adapter *p_HW, unsigned long Bar, unsigned long Off, unsigned long long IntDisable);

unsigned long DMAAllocate(s_Adapter *p_HW, unsigned long Bar, unsigned long Off, unsigned long ChannelIndex, unsigned long BurstSizeB, unsigned long BurstCount, unsigned long PageCount, unsigned long PagesPerMark);
unsigned long DMAFree(s_Adapter *p_HW, unsigned long ChannelIndex);
unsigned long DMASave(s_Adapter *p_HW, unsigned long ChannelIndex, char *DataFile, size_t Bits);

void HoldKeyboard();
unsigned long HoldTimer(unsigned long Time);

unsigned long long ModifyOR(unsigned long long Value, unsigned long long Modifier);
unsigned long long ModifyAND(unsigned long long Value, unsigned long long Modifier);

unsigned long Query(s_Adapter *p_HW, unsigned long Bar, unsigned long Off, char *Operator, unsigned long long Operand, unsigned long Attempts, unsigned long Delay, unsigned long long *Value);

unsigned long Read(s_Adapter *p_HW, unsigned long Bar, unsigned long Off, unsigned long long *Value);

unsigned long Serial(s_Adapter *p_Adapter, unsigned long BAR, unsigned long offset, unsigned long long configure, unsigned long long payload, unsigned long long *read_value);

unsigned long Write(s_Adapter *p_HW, unsigned long Bar, unsigned long Off, unsigned long long Value);

unsigned long Conditional(char *Operator, unsigned long long Operand, unsigned long long Value);

#ifdef __cplusplus
}
#endif

#endif
